
type arete = int * int
type graphe_biparti = bool array array
type couplage = int option array
type chemin = arete list


let graphe_init (n1 : int) (n2 : int) : graphe_biparti = 
  Array.make_matrix n1 n2 false

let graphe_nb_sommets (g : graphe_biparti) = 
  let n1 = Array.length g in
  assert (n1 > 0);
  let n2 = Array.length g.(0) in
  n1, n2

let graphe_ajouter_arete (g : graphe_biparti) ((x, y) : arete) =
  g.(x).(y) <- true

let graphe_supprimer_arete (g : graphe_biparti) ((x, y) : arete) =
  g.(x).(y) <- false

let graphe_tester_arete (g : graphe_biparti) ((x, y) : arete) =
  g.(x).(y)

let graphe_aleatoire (n1 : int) (n2 : int) (p : float) : graphe_biparti =
  let g = graphe_init n1 n2 in
  for x = 0 to n1-1 do 
    for y = 0 to n2-1 do 
      if Random.float 1.0 < p then 
        graphe_ajouter_arete g (x, y)
    done  
  done;
  g

let neato (g : graphe_biparti) (c : couplage) =
  let b = Buffer.create 500 in
  let n1, n2 = graphe_nb_sommets g in
  Printf.bprintf b "graph G {\n"; 
  Printf.bprintf b "  node[shape=\"square\" style=\"filled\"];\n"; 
  for x = 0 to n1-1 do
    Printf.bprintf b "  \"%dg\" [label=\"%d\" pos=\"0,%d!\" fillcolor=\"#ffb2a7\"];\n" x x (-x)
  done;
  for y = 0 to n2-1 do
    Printf.bprintf b "  \"%dd\" [label=\"%d\" pos=\"5,%d!\" fillcolor=\"#aacdea\"];\n" y y (-y)
  done;
  for x = 0 to n1-1 do
    for y = 0 to n2-1 do
      if graphe_tester_arete g (x, y) then
        Printf.bprintf b "  \"%dg\" -- \"%dd\" [%s];\n" x y (if c.(y) = Some x then "penwidth=5" else "penwidth=0.5 style=dashed")
    done;
  done;
  Printf.bprintf b "}\n";
  Buffer.contents b
  
let image (g : graphe_biparti) (c : couplage) (nom_fichier : string) =
  let s = neato g c in
  ignore (Sys.command ("echo '" ^ s ^ "' | neato -Tpng -o " ^ nom_fichier))


(*****************************************************)  
(******************** Début du TP ********************)
(*****************************************************)  
  


(********** Question 1 **********)

let taille_couplage (couplage: couplage) : int =
  failwith "TODO"



(********** Question 2 **********)

let est_couplage (couplage: couplage) (g: graphe_biparti) : bool = 
  failwith "TODO"


(********** Question 3 **********)

let suivant (couplage : couplage) (n1 : int) =
  let n2 = Array.length couplage in
  let rec aux i2 = 
    if i2 >= n2 then false
    else
      failwith "TODO"
  in aux 0

  

(********** Question 4 **********)

let taille_couplage_maximum_naif (g: graphe_biparti) : int =
  failwith "TODO"



(********** Question 6 **********)

let rec difference_symetrique (couplage: couplage) (chemin_augmentant: chemin) : unit =
  failwith "TODO"



(********** Question 7 **********)

let chemin_augmentant g (couplage: couplage) (x : int) : chemin =
  let n1, n2 = graphe_nb_sommets g in
  let visite = Array.make n2 false in
  let rec visiter (x: int) : chemin =
    let r = ref [] in
    failwith "TODO";
    !r
  in visiter x



(********** Question 8 **********)

let couplage_maximum (g: graphe_biparti) : couplage =
  failwith "TODO"

  
